#!/usr/bin/python3

from theoEnc.E2EE import E2EE
from theoEnc.random import random_string

LEN = 499900


seed = random_string(500000)
print("[SERVER] Length of Seed: " + str(len(seed)))

e2ee_server = E2EE(seed)
e2ee_client = E2EE(seed)

print("\n[SERVER] Generating new compressed key part (CKP)...")
ckp = e2ee_server.generate_compressed_key_part(LEN, destroy_used_key=False)
e2ee_server.add_compressed_key_part(ckp)
print("[SERVER] Generated.")
print("[SERVER] Length of Key: " + str(len(e2ee_server.get_key())))

print("[CLIENT] Adding CCP...")
e2ee_client.add_compressed_key_part(ckp)
print("[CLIENT] Added.")
print("[CLIENT] Length of Key: " + str(len(e2ee_client.get_key())))
