#!/usr/bin/python3

from .otp import encrypt_otp, decrypt_otp
from .compress import compress, decompress
from .random import random_string

class E2EE:
    def __init__(self, seed: str):
        self.seed = seed
        self.key = seed

    def get_key(self):
        return self.key

    def add_compressed_key_part(self, ckeypart: bytes):
        length = len(ckeypart)
        ckeypart = decrypt_otp(ckeypart, self.key[length-1:])
        self.key = self.key[length-1:]  # delete the used part of the full key
        self.key += decompress(ckeypart)
        
    def generate_compressed_key_part(self, length: int, destroy_used_key=True):
        ckeypart = random_string(length)
        ckeypart = compress(ckeypart)
        ckeypart_enc = encrypt_otp(ckeypart, self.key[len(ckeypart)-1:])
        if destroy_used_key:
            self.key = self.key[len(ckeypart)-1:] # delete the of the full key which is used now
        return ckeypart_enc

    def addCKeyPart(self, ckeypart: bytes):
        self.add_compressed_key_part(ckeypart, length)
    def generateCKeyPart(self, length: int, destroy_used_key=True):
        self.generate_compressed_key_part(length, destroy_used_key)
